﻿using System;
using System.Web;
using Infragistics.Web.UI.NavigationControls;

namespace ExplorerBarTest
{
    public partial class Default : System.Web.UI.Page
    {
        private int _selectedIndex;

        protected void Page_Load(object sender, EventArgs e)
        {
            //explorerBar.Groups[0].Items[1].CssClass = null;
           // explorerBar.Groups[0].Items[1].SelectedCssClass = "NodeSelected2";

            explorerBar.Groups[0].Items[1].Selected = true;
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            AccordionStyleMenu();
        }

        private void AccordionStyleMenu()
        {
            int nodeCount = SiteMap.RootNode.ChildNodes.Count;
            for (int i = 0; i < nodeCount; i++)
            {
                AccordionTopMenu(i);
            }
        }

        private void AccordionTopMenu(int i)
        {
            var smn = SiteMap.RootNode.ChildNodes[i];

            var barGroup = new ExplorerBarGroup
            {
                Text = SiteMap.RootNode.ChildNodes[i].Title,
                SelectedCssClass = "HeaderSelected",
                ActiveCssClass = "HeaderSelected",
                CssClass = "header"
                //DisabledCssClass = "DisabledNode",
                //HoverCssClass = "header"
            };

            if (smn.Url.ToLower() == Page.Request.Path.ToLower())
            {
                barGroup.Selected = true;
            }
            _selectedIndex = 0;
            if (smn.HasChildNodes)
            {
                if (AddChildren(smn, barGroup, null, i) || smn.Url.Replace("?1", "").Trim().ToLower() == Page.Request.Path.Replace("?1", "").Trim().ToLower())
                {
                    _selectedIndex = i;
                }
            }
            explorerBar.Groups.Add(barGroup);
            explorerBar.Groups[_selectedIndex].Selected = true;
        }

        protected virtual bool AddChildren(SiteMapNode node, ExplorerBarGroup tree, ExplorerBarItem currentTreeNode,
                                           int i)
        {
            bool result = false;

            foreach (SiteMapNode child in node.ChildNodes)
            {
                result = MenuTreeNode(child, currentTreeNode, tree, "Visited",
                                      "Select", i);
            }
            return result;
        }

        private bool MenuTreeNode(SiteMapNode child, ExplorerBarItem currentTreeNode, ExplorerBarGroup tree, 
            string toolTip, string nodeSelection, int i)
        {
            bool result = false;
            var treeNode = new ExplorerBarItem
            {
                Text = child.Title,
                NavigateUrl = child.Url
            };

            treeNode.DisabledCssClass = "DisabledNode";
            treeNode.SelectedCssClass = "NodeSelected";
            treeNode.ActiveCssClass = "NodeSelected";
            //treeNode.CssClass = "PageMenuContent";
            //treeNode.HoverCssClass = "PageMenuContent";

            if (treeNode.Value == "None")
            {
                if (child.Url.Replace("?1", "").Trim().ToLower() == Page.Request.Path.Replace("?1", "").Trim().ToLower())
                {
                    treeNode.Text = child.Title;
                    treeNode.Selected = true;
                }
                else
                {
                    treeNode.Text = child.Title;
                    treeNode.Selected = false;
                }
            }
            if (child.Url.Replace("?1", "").Trim().ToLower() == Page.Request.Path.Replace("?1", "").Trim().ToLower())
            {
                //explorerBar.Groups[i].Selected = true;
                _selectedIndex = i;
                treeNode.Selected = true;
                result = true;
            }


            //Credits SubMenu index is 4
            //When the user is in EIC, and clicked submit the user will be navigated to Dependent Information to enter information
            //but the sidemenu should be in Credits section. So have to hard code the index to credits section
            if (Request.QueryString["eic"] != null && child.Title.ToLower().Trim() == "dependent information")
            {
                _selectedIndex = 4;
                treeNode.Selected = true;
                result = true;
            }

            // You can define additionnal properties in your sitemap nodes
            // We use this features to use icons in TreeNodes.
            //we don't need to build the tree for nodes that are defined in IsInTitleList
            if (!IsInTitleList(child.Title))
            {
                if (currentTreeNode == null)
                    tree.Items.Add(treeNode);
                else
                    currentTreeNode.Items.Add(treeNode);
            }

            if (child.HasChildNodes)
            {
                result |= AddChildren(child, tree, treeNode, i);
            }
            return result;
        }

        private bool IsInTitleList(string checkname)
        {
            bool isFound = false;
            string[] itemList = new string[] {"Payment with Your Return", "Return Refund Information",
                "Refund With Return", "Bank Information", "File Return", "Confirmation",
                "IRA/Keogh and Roth IRA Conversion Distributions", "W-2List",
                "Schedule C Part1", "Schedule C Part2",
                "Schedule C Part3", "Schedule C Part4", "Schedule C Part5", "Schedule C Part6", "Schedule C Summary",
                "Schedule E-1", "Schedule E-2", "Schedule E-3", "Schedule E", "Schedule E Summary",
                "Qualified Care Expenses List", "Qualified Care Expenses Results",
                "Qualified Care", "Tax Rate","M2210 Penalty",
                "Septic Credit Pri Address","Septic Credit Gen Info","Septic Credit Loans","Septic Credit Loan Detail",
                "Septic Credit Actual Cost","Septic Credit Carryover Amount","Septic Credit Summary","Energy Credit Detail",
                "Spouse Unemployment Compensation", "Other Lottery and Gambling Winnings",
                "Lead Paint Credit Costs", "Lead Paint Credit CarryOver",
                "Earned Income Credit Dependents"
            }; // add more items as necessary
            foreach (string s in itemList)
            {
                if (s == checkname)
                {
                    isFound = true;
                }
            }
            return isFound;
        }
    }
}